define("format_multitopic/courseformat/contenttabs/tabtree",["exports","core/reactive","core_courseformat/courseeditor","format_multitopic/courseformat/contenttabs/tab","core/templates"],(function(_exports,_reactive,_courseeditor,_tab,_templates){function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}
/**
   * Course section tabs updater.
   *
   * @module     format_multitopic/courseformat/contenttabs/tabtree
   * @class      format_multitopic/courseformat/contenttabs/tabtree
   * @copyright  2022 Jeremy FitzPatrick and Te Wānanga o Aotearoa
   * @copyright  2023 onwards James Calder and Otago Polytechnic
   * @copyright  based on work by 2021 Ferran Recio <ferran@moodle.com>
   * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
   */Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.default=void 0,_tab=_interopRequireDefault(_tab),_templates=_interopRequireDefault(_templates);class Component extends _reactive.BaseComponent{create(){this.name="contenttabs",this.selectors={TAB:"ul:first-of-type li",CHILDTAB:"ul:nth-child(2) li",SECTION_ITEM:"a.nav-link"},this.classes={ACTIVETAB:"active"},this.tabs={},this.childtabs={},this.activetab=[null,null],this.originalsinglesectionid=document.querySelector("ul.sections").dataset.originalsinglesectionid}static init(target){return new this({element:document.getElementById(target),reactive:(0,_courseeditor.getCurrentCourseEditor)()})}stateReady(){this._indexContents()}getWatchers(){return[{watch:"course.sectionlist:updated",handler:this._refreshCourseSectionTabs}]}async _refreshCourseSectionTabs(_ref){let{element:element}=_ref;const originalSingleSection=this.reactive.get("section",this.originalsinglesectionid);let singleSectionId,singleSection,newActiveTab0id;originalSingleSection?(singleSectionId=originalSingleSection.levelsan<2?originalSingleSection.id:originalSingleSection.pageid,singleSection=singleSectionId==originalSingleSection.id?originalSingleSection:this.reactive.get("section",singleSectionId)):(singleSectionId=null,singleSection=null),newActiveTab0id=singleSection?singleSection.levelsan>=1?singleSection.parentid:singleSection.id:null;let tabsSecondRowDom=this.element.querySelector("ul:nth-of-type(2)");const tabsSecondRowShow=singleSection&&(element.tabsdata.length>1||element.tabsdata[0].subtree.length>1);if(tabsSecondRowShow&&!tabsSecondRowDom){this.element.querySelector("ul:first-of-type").insertAdjacentElement("afterend",tabsSecondRowDom=document.createElement("ul")),tabsSecondRowDom.className="nav nav-tabs mb-3";const addTab0Dom=this.element.querySelector("ul:first-of-type li:last-of-type");let data={level:1,active:!1,inactive:!1,link:[{link:addTab0Dom.querySelector("a").getAttribute("href").replace(/\binsertlevel=0\b/,"insertlevel=1")}],title:addTab0Dom.getAttribute("title"),text:'<i class="icon fa fa-plus fa-fw" title="'+addTab0Dom.getAttribute("title")+'"></i>'},item=document.createElement("li");tabsSecondRowDom.insertAdjacentElement("beforeend",item);let html=await _templates.default.render("format_multitopic/courseformat/contenttabs/tab",data);item=_templates.default.replaceNode(item,html,"")[0]}else tabsSecondRowDom&&!tabsSecondRowShow&&tabsSecondRowDom.remove();let toptabslist=[],childtabslist=[];for(let tabdata of element.tabsdata)if(toptabslist.push(tabdata.sectionid),tabdata.sectionid==newActiveTab0id)for(let tabdata2 of tabdata.subtree)childtabslist.push(tabdata2.sectionid);let toptabs=this.element.querySelector("ul:first-of-type");if(await this._fixOrder(toptabs,toptabslist,this.selectors.TAB,0,element.tabsdata[0].subtree.length>1),tabsSecondRowShow){let childtabs=this.element.querySelector("ul:nth-of-type(2)");await this._fixOrder(childtabs,childtabslist,this.selectors.CHILDTAB,1,!1)}this._changeActiveTabs(newActiveTab0id,tabsSecondRowShow?singleSection.id:null),this._indexContents()}_changeActiveTabs(newActiveTab0id,newActiveTab1id){if(newActiveTab0id!=this.activetab[0]){var _this$element$querySe,_this$element$querySe2;let anchor=null===(_this$element$querySe=this.element.querySelector('ul:first-of-type div[data-itemid="'+this.activetab[0]+'"]'))||void 0===_this$element$querySe?void 0:_this$element$querySe.parentElement;if(anchor){let section=this.reactive.get("section",this.activetab[0]);anchor.classList.remove("active"),anchor.href=section.sectionurl.replace("&amp;","&")}if(this.activetab[0]=newActiveTab0id,anchor=null===(_this$element$querySe2=this.element.querySelector('ul:first-of-type div[data-itemid="'+this.activetab[0]+'"]'))||void 0===_this$element$querySe2?void 0:_this$element$querySe2.parentElement,anchor&&(anchor.classList.add("active"),anchor.removeAttribute("href")),newActiveTab1id){const addAnchor=this.element.querySelector("ul:nth-of-type(2) li:last-of-type a"),addLink=addAnchor.href.replace(/\binsertparentid=\d+\b/,"insertparentid="+this.activetab[0]);addAnchor.setAttribute("href",addLink)}}if(newActiveTab1id&&newActiveTab1id!=this.activetab[1]){var _this$element$querySe3,_this$element$querySe4;let anchor=null===(_this$element$querySe3=this.element.querySelector('ul:nth-of-type(2) div[data-itemid="'+this.activetab[1]+'"]'))||void 0===_this$element$querySe3?void 0:_this$element$querySe3.parentElement;if(anchor){let section=this.reactive.get("section",this.activetab[1]);anchor.classList.remove("active"),anchor.href=section.sectionurl.replace("&amp;","&")}this.activetab[1]=newActiveTab1id,anchor=null===(_this$element$querySe4=this.element.querySelector('ul:nth-of-type(2) div[data-itemid="'+this.activetab[1]+'"]'))||void 0===_this$element$querySe4?void 0:_this$element$querySe4.parentElement,anchor&&(anchor.classList.add("active"),anchor.removeAttribute("href"))}this.activetab[1]=newActiveTab1id}_indexContents(){this._scanIndex(this.selectors.TAB,this.tabs,(item=>new _tab.default(item)),0),this._scanIndex(this.selectors.CHILDTAB,this.childtabs,(item=>new _tab.default(item)),1)}_scanIndex(selector,index,creationhandler,level){this.getElements("".concat(selector,":not([data-indexed])")).forEach((item=>{var _item$dataset;if(null==item||null===(_item$dataset=item.dataset)||void 0===_item$dataset||!_item$dataset.id)return;void 0!==index[item.dataset.id]&&index[item.dataset.id].unregister(),index[item.dataset.id]=creationhandler({...this,element:item}),item.querySelector("a").classList.contains(this.classes.ACTIVETAB)&&(this.activetab[level]=item.dataset.id),item.dataset.indexed=!0}))}async _fixOrder(container,neworder,selector,level,hassubtree){if(!neworder.length)return container.classList.add("hidden"),void(container.innerHTML="");container.classList.remove("hidden");for(const[index,itemid]of Object.entries(neworder)){const section=this.reactive.get("section",itemid),visible=(section.visible&&section.available||0==section.section)&&(neworder.length>1||hassubtree),current=null!=section.currentnestedlevel&&section.currentnestedlevel>=level;let item=this.getElement(selector,itemid);if(null===item){let data={sectionid:itemid,level:level,active:0,inactive:0,link:[{link:section.sectionurl}],title:section.name,text:'<div class="tab_content'+(visible?"":" dimmed")+(current?" marker":"")+'" data-itemid="'+section.id+'">'+section.title+"</div>"};item=document.createElement("li"),container.insertBefore(item,container.lastElementChild);let html=await _templates.default.render("format_multitopic/courseformat/contenttabs/tab",data);item=_templates.default.replaceNode(item,html,"")[0]}const content=item.querySelector("div.tab_content");content&&content.classList.contains("dimmed")==visible&&(visible?content.classList.remove("dimmed"):content.classList.add("dimmed")),content&&content.classList.contains("marker")!=current&&(current?content.classList.add("marker"):content.classList.remove("marker"));const currentitem=container.children[index];if(void 0===currentitem)return void container.append(item);currentitem!==item&&container.insertBefore(item,currentitem)}for(;container.children.length>neworder.length+1;)container.removeChild(container.lastElementChild.previousSibling)}}return _exports.default=Component,_exports.default}));

//# sourceMappingURL=tabtree.min.js.map